<?php
/*
Plugin Name: Google Analytics Popular Posts
Plugin URI: http://wordpress.org/extend/plugins/google-analytics-popular-posts/
Description: This plugin uses Google Analytics API to fetch data from your analytics account and displays popular posts in the widget.
Version: 1.0.2
Author: koichiyaima
Author URI: http://yaima.sakuraweb.com/
*/
/*  Copyright 2011 Yaima surf (email : yaima-surf@yaima.sakuraweb.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public Licen se as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

/**
 * GoogleAnalyticsPopularPosts Class
 */
class GoogleAnalyticsPopularPosts extends WP_Widget {

	// Constructor
	function GoogleAnalyticsPopularPosts() {
		$widget_ops = array( 'description' => 'This plugin uses Google Analytics API to fetch data from your analytics account and displays popular posts in the widget.');
		parent::WP_Widget(false, $name = 'Google Analytics Popular Posts',$widget_ops);
	}

	// WP_Widget::form
	function form($instance) {
		$title = strip_tags($instance['title']);
		$GAPP_usr = esc_attr($instance['GoogleAnalyticsPopularPosts_username']);
		$GAPP_pwd = esc_attr($instance['GoogleAnalyticsPopularPosts_password']);
		$GAPP_pID = esc_attr($instance['GoogleAnalyticsPopularPosts_profileID']);
		$GAPP_mRs = esc_attr($instance['GoogleAnalyticsPopularPosts_maxResults']);
		$GAPP_aSDs = esc_attr($instance['GoogleAnalyticsPopularPosts_statsSinceDays']);
		$GAPP_filter = esc_attr($instance['GoogleAnalyticsPopularPosts_filter']);
		?>

		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_username'); ?>"><?php _e('Google Analytics Username:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_username'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_username'); ?>" type="text" value="<?php echo $GAPP_usr; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_password'); ?>"><?php _e('Google Analytics Password:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_password'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_password'); ?>" type="text" value="<?php echo $GAPP_pwd; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_profileID'); ?>"><?php _e('Google Analytics Profile ID: (UA-xxxxxxx-xx is not the Profile ID)'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_profileID'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_profileID'); ?>" type="text" value="<?php echo $GAPP_pID; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_maxResults'); ?>"><?php _e('Popular Posts Max Results:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_maxResults'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_maxResults'); ?>" type="text" value="<?php echo $GAPP_mRs; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>"><?php _e('Stats Since Days:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_statsSinceDays'); ?>" type="text" value="<?php echo $GAPP_aSDs; ?>" /></label></p>
		<p><label for="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_filter'); ?>"><?php _e('GAPI Filter: (example) ga:pagePath=~^/blog'); ?> <input class="widefat" id="<?php echo $this->get_field_id('GoogleAnalyticsPopularPosts_filter'); ?>" name="<?php echo $this->get_field_name('GoogleAnalyticsPopularPosts_filter'); ?>" type="text" value="<?php echo $GAPP_filter; ?>" /></label></p>

		<?php
	}

	// WP_Widget::update
	function update($new_instance, $old_instance) {
		return $new_instance;
	}
	
	// WP_Widget::widget
	function widget( $args, $instance ) {
		extract($args);
		$title = apply_filters('widget_title', empty($instance['title']) ? '' : $instance['title']);
		$GAPP_usr = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_username']) ? '' : $instance['GoogleAnalyticsPopularPosts_username']);
		$GAPP_pwd = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_password']) ? '' : $instance['GoogleAnalyticsPopularPosts_password']);
		$GAPP_pID = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_profileID']) ? '' : $instance['GoogleAnalyticsPopularPosts_profileID']);
		$GAPP_mRs = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_maxResults']) ? '' : $instance['GoogleAnalyticsPopularPosts_maxResults']);
		$GAPP_aSDs = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_statsSinceDays']) ? '' : $instance['GoogleAnalyticsPopularPosts_statsSinceDays']);
		$GAPP_filter = apply_filters('widget_title', empty($instance['GoogleAnalyticsPopularPosts_filter']) ? '' : $instance['GoogleAnalyticsPopularPosts_filter']);
		echo $before_widget;
		if ( !empty( $title ) ) {
			echo $before_title . $title . $after_title;
		}
		if(is_numeric($GAPP_aSDs)) {
			$todays_year = date("Y");
			$todays_month = date("m");
			$todays_day = date("d");
			$date = "$todays_year-$todays_month-$todays_day";
			$newdate = strtotime ( "-$GAPP_aSDs day" , strtotime ( $date ) ) ;
			$newdate = date ( 'Y-m-d' , $newdate );
			$From = $newdate;
		}
		define('ga_email', $GAPP_usr);
		define('ga_password', $GAPP_pwd);
		define('ga_profile_id', $GAPP_pID);
		require 'gapi.class.php';
		$ga = new gapi(ga_email, ga_password);
		$ga->requestReportData(ga_profile_id, array('pagePath'), array('visits'), array('-visits'), $filter=$GAPP_filter, $start_date=$From, $end_date=$date, $start_index=1, $max_results=$GAPP_mRs);
		?>
		
		<li id="popular_post">
			<p class="popular_date"><?php echo $From ?> ～ <?php echo $date ?></p>

			<?php
				foreach($ga->getResults() as $result):
					$tmpPagepath= $result->getPagepath();
					$tmpPagepath= get_bloginfo('siteurl').$tmpPagepath;
					$tmpPostID = url_to_postid($tmpPagepath);
					$tmptitleStr = get_the_title($tmpPostID);
			?>

			<div class="popular_post"><a href='<?php echo $tmpPagepath ?>'><?php echo $tmptitleStr ?></a></div>

		<?php
			endforeach
		?>
		</li>		

		<?php
		echo $after_widget;
		}
} // class GoogleAnalyticsPopularPosts

// register Google Analytics Popular Posts widget
function GoogleAnalyticsPopularPostsInit() {
    register_widget('GoogleAnalyticsPopularPosts');
}

add_action('widgets_init', 'GoogleAnalyticsPopularPostsInit');
?>